# Use 5.1.2 snapshot there was no release tagged by upstream,
# but this is what is available in maven central
%global git_tag e0570bff5c60604115ab7ad0d5498055a60fc772

Name:           maven-indexer
Version:        5.1.2
Release:        0.4.gite0570bf%{?dist}
Summary:        Standard for producing indexes of Maven repositories

License:        ASL 2.0
URL:            http://maven.apache.org/maven-indexer/index.html

Source0:        https://github.com/apache/maven-indexer/archive/%{git_tag}/maven-indexer-%{version}.tar.gz

# Port to latest lucene
Patch0:         0001-Port-to-Lucene-5.patch
Patch1:         0002-Port-to-Lucene-6.patch

# Drop dep on truezip
Patch2:         maven-indexer-truezip.patch

BuildArch:      noarch

BuildRequires:  maven-local
BuildRequires:  mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires:  mvn(org.apache.lucene:lucene-analyzers-common)
BuildRequires:  mvn(org.apache.lucene:lucene-core)
BuildRequires:  mvn(org.apache.lucene:lucene-highlighter)
BuildRequires:  mvn(org.apache.lucene:lucene-queryparser)
BuildRequires:  mvn(org.apache.maven.archetype:archetype-common)
BuildRequires:  mvn(org.apache.maven:maven-model)
BuildRequires:  mvn(org.apache.maven:maven-parent:pom:)
BuildRequires:  mvn(org.apache.maven.plugins:maven-failsafe-plugin)
BuildRequires:  mvn(org.apache.maven.wagon:wagon-provider-api)
BuildRequires:  mvn(org.codehaus.plexus:plexus-component-annotations)
BuildRequires:  mvn(org.codehaus.plexus:plexus-component-metadata)
BuildRequires:  mvn(org.codehaus.plexus:plexus-container-default)
BuildRequires:  mvn(org.codehaus.plexus:plexus-utils)
BuildRequires:  mvn(org.eclipse.aether:aether-api)
BuildRequires:  mvn(org.eclipse.aether:aether-util)

%description
Apache Maven Indexer (former Sonatype Nexus Indexer) is the defacto
standard for producing indexes of Maven repositories. The Indexes
are produced and consumed by all major tools in the ecosystem.

%package javadoc
Summary:        Javadocs for %{name}

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n %{name}-%{git_tag}
%patch0 -p1
%patch1 -p1
%patch2

find -name '*.jar' -delete
find -name '*.zip' -delete
find -name '*.class' -delete

# Tests need porting to a modern jetty
%pom_remove_dep -r org.mortbay.jetty:jetty

# Switch from sonatype aether to eclipse aether
%pom_remove_dep org.sonatype.aether:aether-api indexer-core
%pom_remove_dep org.sonatype.aether:aether-util indexer-core
%pom_add_dep org.eclipse.aether:aether-api indexer-core
%pom_add_dep org.eclipse.aether:aether-util indexer-core
find -name *.java -exec sed -i -e "s/org.sonatype.aether/org.eclipse.aether/g" {} \;

# Switch from sonatype to codehaus plexus
%pom_remove_dep org.sonatype.sisu:sisu-inject-plexus indexer-cli
%pom_remove_dep org.sonatype.sisu:sisu-inject-plexus indexer-core
%pom_remove_dep org.sonatype.sisu:sisu-inject-plexus indexer-artifact
%pom_add_dep org.codehaus.plexus:plexus-container-default indexer-cli
%pom_add_dep org.codehaus.plexus:plexus-container-default indexer-core
%pom_add_dep org.codehaus.plexus:plexus-container-default indexer-artifact

# Remove unnecessary plugins
%pom_remove_plugin :maven-enforcer-plugin
%pom_remove_plugin :apache-rat-plugin

# Disable CLI module because of how it bundles stuff
%pom_disable_module indexer-cli

# Drop unneeded dep on truezip
%pom_remove_dep -r de.schlichtherle.truezip:
rm indexer-core/src/main/java/org/apache/maven/index/util/zip/TrueZipZipFileHandle.java

%build
# Skip tests because they need porting to modern jetty
%mvn_build -f

%install
%mvn_install

%files -f .mfiles
%license NOTICE
%doc README.md

%files javadoc -f .mfiles-javadoc
%license NOTICE

%changelog
* Tue Aug 08 2017 Mat Booth <mat.booth@redhat.com> - 5.1.2-0.4.gite0570bf
- Improved lucene porting patches

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 5.1.2-0.3.gite0570bf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Tue Jun 27 2017 Mat Booth <mat.booth@redhat.com> - 5.1.2-0.2.gite0570bf
- Update lucene patch

* Tue Feb 07 2017 Mat Booth <mat.booth@redhat.com> - 5.1.2-0.1.gite0570bf
- Update to 5.1.2 snapshot (as available in Maven Central)
- Port to Lucene 5
- Drop unneeded dep on truezip
- Adopt license macro

* Mon Dec 05 2016 Mat Booth <mat.booth@redhat.com> - 5.1.1-10
- Regenerate BRs

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 5.1.1-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Sat Dec 12 2015 Gerard Ryan <galileo@fedoraproject.org> - 5.1.1-8
- Build against lucene3 now that it's available (& expected here)

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.1.1-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.1.1-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sat Mar 22 2014 Gerard Ryan <galileo@fedoraproject.org> - 5.1.1-5
- Switch to java-headless requires
- Add patch for lucene 4 API changes

* Sat Aug 24 2013 Gerard Ryan <galileo@fedoraproject.org> - 5.1.1-4
- Stop building indexer-cli that bundles lots of stuff

* Mon Aug 12 2013 Stanislav Ochotnicky <sochotnicky@redhat.com> - 5.1.1-3
- Remove unneeded animal-sniffer dependency

* Sat Aug 10 2013 Gerard Ryan <galileo@fedoraproject.org> - 5.1.1-2
- [RHBZ-958162] Migrate from aether to its subpackages
- Remove dependency on jetty-start, since it's for test

* Sat Aug 10 2013 Gerard Ryan <galileo@fedoraproject.org> - 5.1.1-1
- Update to version 5.1.1
- Replace patches with POM macros
- [RHBZ-985695] Replace sisu dependency
- [RHBZ-985705] Use new eclipse version of aether
- Clean up to use new maven guidelines and macros

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.1.2-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.1.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 4.1.2-4
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Wed Jul 25 2012 Gerard Ryan <galileo@fedoraproject.org> - 4.1.2-3
- Don't install super jar created by maven-shade-plugin indexer-core-*-cli.jar

* Wed Jul 25 2012 Gerard Ryan <galileo@fedoraproject.org> - 4.1.2-2
- Remove jars that we don't want to redistribute here from source zip in srpm.

* Mon Jul 09 2012 Gerard Ryan <galileo@fedoraproject.org> - 4.1.2-1
- Initial package.
